

var foofox = {
  onLoad: function() {
    this.strings = document.getElementById("foofox-strings");
    
    this.icon = document.getElementById("foofox-status");
    this.toggleItem = document.getElementById("foofox-toggle");
    this.toggleTwitterItem = document.getElementById("foofox-toggle-twitter");
    
    // Watch/read preferences
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefBranch);
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefService);
    this.prefs = prefs.getBranch("extensions.foofox.");
    this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
    this.prefs.addObserver("", this, false);
    this.observe();
    
    this.currentSong = null;
  },
  toggle : function () {
    this.prefs.setBoolPref("enabled",!this.enabled);
  },
  toggleTwitter : function () {
    this.prefs.setBoolPref("twitter.enabled",!this.twitterEnabled);
  },
  observe : function () {
    this.enabled = this.prefs.getBoolPref("enabled");
    this.twitterEnabled = this.prefs.getBoolPref("twitter.enabled");
    if (!this.enabled && this._updateInterval) {
      window.clearInterval(this._updateInterval);
      this._updateInterval = null;
    }
    if (this.enabled && !this._updateInterval) {
      this.initFoobarWatcher();
    }
    if (!this.enabled)
      this.foobarDisabled();
    this.icon.setAttribute("off",this.enabled?"false":"true");
    this.toggleItem.setAttribute("checked",this.enabled?"true":"false");
    this.toggleTwitterItem.setAttribute("checked",this.twitterEnabled?"true":"false");
  },
  
  search : function (website) {
    if (!this.currentInfo) return;
    var i = this.currentInfo;
    if (website=="wikipedia") {
      url = "http://www.wikipedia.org/search-redirect.php?language=en&search="+encodeURIComponent(i.artist+" "+i.album);
    } else if (website=="myspace") {
      url = "http://searchservice.myspace.com/index.cfm?fuseaction=sitesearch.results&orig=search_Header&origpfc=Splash&type=People&qry="+encodeURIComponent(i.artist);
    } else if (website=="google") {
      url = "http://google.com/search?q="+encodeURIComponent((i.artist?"'"+i.artist+'"':"")+" "+(i.album?'"'+i.album+'"':"")+" "+(i.track?'"'+i.track+'"':""));
    } else {
      return;
    }
    gBrowser.selectedTab = gBrowser.addTab(url);

  },
  
  initFoobarWatcher : function () {
    Components.utils.import("resource://gre/modules/ctypes.jsm");
    
    var lib = ctypes.open("C:\\WINDOWS\\system32\\user32.dll");
    
    var findWindowEx = lib.declare("FindWindowW",
                                   ctypes.stdcall_abi,
                                   ctypes.int32_t,
                                   ctypes.ustring,
                                   ctypes.int32_t);
    
    var getWindowText = lib.declare("GetWindowTextW",
                                   ctypes.stdcall_abi,
                                   ctypes.int32_t,
                                   ctypes.int32_t,
                                   ctypes.ustring,
                                   ctypes.int32_t);
    var win = null;
    function update() {
      try {
        //if (!win)
        //  win = findWindowEx("{97E27FAA-C0B3-4b8e-A693-ED7881E99FC1}", 0);
        if (!win)
          win = findWindowEx("{DA7CD0DE-1602-45e6-89A1-C2CA151E008E}/1", 0);
        if (!win)
          win = findWindowEx("{DA7CD0DE-1602-45e6-89A1-C2CA151E008E}", 0);
        if (!win)
          win = findWindowEx("{97E27FAA-C0B3-4b8e-A693-ED7881E99FC1}", 0); // Foobar 0.9.5.3
        if (!win)
          win = findWindowEx("{E7076D1C-A7BF-4f39-B771-BCBE88F2A2A8}", 0);// Foobar Columns UI
        
        Components.utils.reportError("win = "+win);
        
        if (!win)
          return foofox.foobarNotHere();
        
        var text="";
        var max_len = 100;
        for(var i=0; i<max_len; i++)
          text+=" ";
        var text_len = getWindowText(win,text,100);
        
        var m = text.match(/(.*) - (?:\[([^#]+)([^\]]+)\] |)(.*) \[foobar2000.*\]/);
        if (m && m.length>=4)
        return foofox.updateSong( {
          artist : m[1]?m[1].replace(/\s+$/,""):"",
          album : m[2]?m[2].replace(/\s+$/,""):"",
          trackNumber : m[3]?m[3].replace(/#/,""):"",
          track : m[4]?m[4].replace(/\s+$/,""):""
        } );
        
        var m = text.match(/(.*) \[foobar2000.*\]/);
        if (m)
        return foofox.updateSong( {
          artist : "",
          album : "",
          trackNumber : "",
          track : m[1].replace(/\s+$/,"")
        } );
        
        return foofox.foobarIsOff();
        
      } catch(e) {
        Components.utils.reportError("exception : "+e);
        win = null;
        foofox.foobarNotHere();
      }
    }
    this._updateInterval = window.setInterval(update,3000);
  },
  setStatus : function (msg) {
    this.icon.setAttribute("tooltiptext", msg);
  },
  updateSong : function (info) {
    this.currentInfo = info;
    var newSong = (info.artist?info.artist+" - ":"")+info.track;
    if (newSong != this.currentSong) {
      this.setStatus(newSong);
      this.currentSong = newSong;
      this.postTwitterUpdate("foobarfox", "", "playing : "+newSong, function (url) {alert(url);});
    }
  },
  foobarNotHere : function () {
    this.currentSong=null;
    this.setStatus("Foofox - Foobar is not launched");
  },
  foobarIsOff : function () {
    this.currentSong=null;
    this.setStatus("Foofox - Foobar is off" );
  },
  foobarDisabled : function () {
    this.currentSong=null;
    this.setStatus("Foofox - Disabled" );
  },
  postTwitterUpdate : function (username, password, text, callback) {
    if (!this.twitterEnabled) return;
    
    var url = "http://twitter.com/statuses/update.json";
    var params = "source=foobarfox&status=" + encodeURIComponent(text);
    var request = new XMLHttpRequest();
    if (username && password)
      request.open("POST", url, true, username, password);
    else
      request.open("POST", url, true);
    request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    request.setRequestHeader("Content-Length", params.length);
    request.setRequestHeader("Connection", "close");
    request.onreadystatechange = function() {
      if ((request.readyState == 4) && (request.status == 200)) {
        var response = JSON.parse(request.responseText);
        var tweetUrl = 'http://twitter.com/' + response.user.screen_name + '/status/' + response.id
        callback(tweetUrl);
      }
    };
    request.send(params);
  }
};

window.addEventListener("load", function () {foofox.onLoad()}, false);
